%global eclipse_dropin %{_datadir}/eclipse/dropins

%global git_rev 86c0d14265995c53ef7a28f5a57e0150eff529cd

Name:      eclipse-testng
Version:   6.8.6
Release:   4%{?dist}
Summary:   TestNG plug-in for Eclipse
License:   ASL 2.0
URL:       http://testng.org

BuildArch: noarch

# This is a git snapshot because upstream do not tag their releases. Inspection of the contained classes
# shows that this is the code that makes up the 6.8.6 release available in upstream's update site.
Source0:   https://github.com/cbeust/testng-eclipse/archive/%{git_rev}.tar.gz

# Fix embedded lib names
Patch0:    eclipse-testng-manifest.patch

# This patch is sent upstream: https://github.com/cbeust/testng-eclipse/pull/115
Patch1:    eclipse-testng-fix-luna-build.patch

Requires: eclipse-platform
Requires: eclipse-jdt
Requires: guava
Requires: google-guice
Requires: junit
Requires: hamcrest
Requires: testng >= 6.8
Requires: beust-jcommander
Requires: snakeyaml
Requires: base64coder

BuildRequires: java-devel
BuildRequires: eclipse-pde
BuildRequires: eclipse-jdt
BuildRequires: guava
BuildRequires: google-guice
BuildRequires: junit
BuildRequires: hamcrest
BuildRequires: testng >= 6.8
BuildRequires: beust-jcommander
BuildRequires: snakeyaml
BuildRequires: base64coder

%description
The Eclipse TestNG plug-in integrates the TestNG testing framework into the
Eclipse IDE.

%prep
%setup -q -n testng-eclipse-%{git_rev}
%patch0 -p0
%patch1 -p1

# remove bundled libs
rm -f lib/*
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;

# build against fedora packaged libs
build-jar-repository -s -p lib \
  guava testng junit hamcrest/core snakeyaml base64coder google-guice beust-jcommander slf4j/api cglib aopalliance

# the version of the plugin was (and remains) typo'd, see comments on the following commit:
# https://github.com/cbeust/testng-eclipse/commit/86199dbcc081404466a3f7bc7117fad9461b7067
sed -i -e 's@6\.8\.1\.20130330_0839@%{version}.qualifier@g' META-INF/MANIFEST.MF
sed -i -e 's@6\.1\.1\.20110823_1537@%{version}.qualifier@g' testng-eclipse-feature/feature.xml

%build
eclipse-pdebuild -a "-DjavacSource=1.5 -DjavacTarget=1.5"

%install
install -d -m 755 %{buildroot}%{eclipse_dropin}
unzip -q -n -d %{buildroot}%{eclipse_dropin}/testng-eclipse build/rpmBuild/org.testng.eclipse.zip

# need to recreate the symlinks to libraries that were setup in "prep"
# this will cause some benign dangling-symlink rpmlint warnings
pushd %{buildroot}%{eclipse_dropin}/testng-eclipse/eclipse/plugins/org.testng.eclipse_*
rm lib/*.jar
build-jar-repository -s -p lib \
  guava testng junit hamcrest/core snakeyaml base64coder google-guice beust-jcommander slf4j/api cglib aopalliance
popd

%files
# there is no separate licence file, but this file contains an embedded copy of it
%doc testng-eclipse-feature/feature.xml
%{eclipse_dropin}/testng-eclipse

%changelog
* Wed Jul 30 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-4
- Restore testng as an embedded lib due to runtime issues

* Mon Jun 16 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-3
- Use orbit style deps instead of symlinked libs embedded in the plug-in

* Thu Jun 12 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-2
- Patch for compatibility with eclipse luna

* Thu Jun 12 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-1
- Update to latest upstream release.

* Fri Mar 14 2014 Mat Booth <fedora@matbooth.co.uk> - 6.8.5-2.20130625gite0f6037
- Add BR/R on google-guice.

* Tue Jun 25 2013 Mat Booth <fedora@matbooth.co.uk> - 6.8.5-1.20130625gite0f6037
- Initial package.
